package dev.shadowsoffire.apotheosis.adventure.affix.salvaging;

import net.minecraft.client.gui.components.Button;
import net.minecraft.client.resources.model.BakedModel;
import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.client.renderer.texture.OverlayTexture;
import net.minecraft.world.item.ItemDisplayContext;
import com.mojang.blaze3d.platform.Lighting;
import net.minecraft.world.entity.LivingEntity;
import com.mojang.blaze3d.platform.GlStateManager;
import it.unimi.dsi.fastutil.ints.IntSet;
import net.minecraft.client.renderer.MultiBufferSource;
import java.util.function.Function;
import dev.shadowsoffire.apotheosis.adventure.client.GrayBufferSource;
import it.unimi.dsi.fastutil.ints.IntOpenHashSet;
import com.mojang.blaze3d.systems.RenderSystem;
import net.minecraft.world.inventory.InventoryMenu;
import net.minecraft.client.gui.GuiGraphics;
import java.util.Iterator;
import net.minecraft.world.inventory.Slot;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.Level;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.components.events.GuiEventListener;
import net.minecraft.ChatFormatting;
import java.util.ArrayList;
import net.minecraft.world.inventory.AbstractContainerMenu;
import net.minecraft.world.entity.player.Inventory;
import dev.shadowsoffire.apotheosis.adventure.client.SimpleTexButton;
import java.util.List;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.Component;
import dev.shadowsoffire.apotheosis.adventure.client.AdventureContainerScreen;

public class SalvagingScreen extends AdventureContainerScreen<SalvagingMenu>
{
    public static final Component TITLE;
    public static final ResourceLocation TEXTURE;
    protected List<SalvagingRecipe.OutputData> results;
    protected SimpleTexButton salvageBtn;
    
    public SalvagingScreen(final SalvagingMenu menu, final Inventory inv, final Component title) {
        super((AbstractContainerMenu)menu, inv, SalvagingScreen.TITLE);
        this.results = new ArrayList<SalvagingRecipe.OutputData>();
        ((SalvagingMenu)this.f_97732_).addSlotListener((id, stack) -> this.computeResults());
        this.f_97727_ = 174;
    }
    
    protected void m_7856_() {
        super.m_7856_();
        final int left = this.getGuiLeft();
        final int top = this.getGuiTop();
        this.salvageBtn = (SimpleTexButton)this.m_142416_((GuiEventListener)new SimpleTexButton(left + 98, top + 34, 18, 18, 238, 0, SalvagingScreen.TEXTURE, 256, 256, btn -> this.f_96541_.f_91072_.m_105208_(((SalvagingMenu)this.f_97732_).f_38840_, 0), (Component)Component.m_237115_("button.apotheosis.salvage")).setInactiveMessage((Component)Component.m_237115_("button.apotheosis.no_salvage").m_130940_(ChatFormatting.RED)));
        this.computeResults();
    }
    
    public void computeResults() {
        if (this.salvageBtn == null) {
            return;
        }
        final ArrayList<SalvagingRecipe.OutputData> matches = new ArrayList<SalvagingRecipe.OutputData>();
        for (int i = 0; i < 15; ++i) {
            final Slot s = ((SalvagingMenu)this.f_97732_).m_38853_(i);
            final ItemStack stack = s.m_7993_();
            final SalvagingRecipe recipe = SalvagingMenu.findMatch((Level)Minecraft.m_91087_().f_91073_, stack);
            if (recipe != null) {
                for (final SalvagingRecipe.OutputData d : recipe.getOutputs()) {
                    final int[] counts = SalvagingMenu.getSalvageCounts(d, stack);
                    matches.add(new SalvagingRecipe.OutputData(d.stack, counts[0], counts[1]));
                }
            }
        }
        final List<SalvagingRecipe.OutputData> compressed = new ArrayList<SalvagingRecipe.OutputData>();
        for (final SalvagingRecipe.OutputData data : matches) {
            if (data == null) {
                continue;
            }
            boolean success = false;
            for (final SalvagingRecipe.OutputData existing : compressed) {
                if (ItemStack.m_150942_(data.stack, existing.stack)) {
                    final SalvagingRecipe.OutputData outputData = existing;
                    outputData.min += data.min;
                    final SalvagingRecipe.OutputData outputData2 = existing;
                    outputData2.max += data.max;
                    success = true;
                    break;
                }
            }
            if (success) {
                continue;
            }
            compressed.add(data);
        }
        this.results = compressed;
        this.salvageBtn.f_93623_ = !this.results.isEmpty();
    }
    
    public void m_88315_(final GuiGraphics gfx, final int pMouseX, final int pMouseY, final float pPartialTick) {
        this.m_280273_(gfx);
        super.m_88315_(gfx, pMouseX, pMouseY, pPartialTick);
        RenderSystem.setShaderTexture(0, InventoryMenu.f_39692_);
        RenderSystem.enableBlend();
        final int maxDisplay = Math.min(6, this.results.size());
        final IntSet skipSlots = (IntSet)new IntOpenHashSet();
        for (int i = 0; i < maxDisplay; ++i) {
            final ItemStack display = this.results.get(i).stack;
            int displaySlot = -1;
            for (int slot = 12; slot < 18; ++slot) {
                if (!skipSlots.contains(slot)) {
                    final ItemStack outStack = ((Slot)((SalvagingMenu)this.f_97732_).f_38839_.get(slot)).m_7993_();
                    if (outStack.m_41619_()) {
                        displaySlot = slot;
                        skipSlots.add(slot);
                        break;
                    }
                    if (outStack.m_150930_(display.m_41720_())) {
                        break;
                    }
                }
            }
            if (displaySlot != -1) {
                final Slot slot2 = ((SalvagingMenu)this.f_97732_).m_38853_(displaySlot);
                renderGuiItem(gfx, display, this.getGuiLeft() + slot2.f_40220_, this.getGuiTop() + slot2.f_40221_, (Function<MultiBufferSource, MultiBufferSource>)GrayBufferSource::new);
            }
        }
        this.m_280072_(gfx, pMouseX, pMouseY);
    }
    
    public static void renderGuiItem(final GuiGraphics gfx, final ItemStack pStack, final int pX, final int pY, final Function<MultiBufferSource, MultiBufferSource> wrapper) {
        Minecraft.m_91087_().f_90987_.m_118506_(InventoryMenu.f_39692_).m_117960_(false, false);
        RenderSystem.setShaderTexture(0, InventoryMenu.f_39692_);
        RenderSystem.enableBlend();
        RenderSystem.blendFunc(GlStateManager.SourceFactor.SRC_ALPHA, GlStateManager.DestFactor.ONE_MINUS_SRC_ALPHA);
        RenderSystem.setShaderColor(1.0f, 1.0f, 1.0f, 1.0f);
        final PoseStack posestack = gfx.m_280168_();
        posestack.m_85836_();
        posestack.m_252880_((float)pX, (float)pY, 100.0f);
        posestack.m_85837_(8.0, 8.0, 0.0);
        posestack.m_85841_(1.0f, -1.0f, 1.0f);
        posestack.m_85841_(16.0f, 16.0f, 16.0f);
        final Minecraft mc = Minecraft.m_91087_();
        final BakedModel model = mc.m_91291_().m_174264_(pStack, (Level)mc.f_91073_, (LivingEntity)mc.f_91074_, pX ^ pY);
        final boolean flag = !model.m_7547_();
        if (flag) {
            Lighting.m_84930_();
        }
        final MultiBufferSource.BufferSource buffer = Minecraft.m_91087_().m_91269_().m_110104_();
        Minecraft.m_91087_().m_91291_().m_115143_(pStack, ItemDisplayContext.GUI, false, posestack, (MultiBufferSource)wrapper.apply((MultiBufferSource)buffer), 15728880, OverlayTexture.f_118083_, model);
        buffer.m_109911_();
        RenderSystem.enableDepthTest();
        if (flag) {
            Lighting.m_84931_();
        }
        posestack.m_85849_();
    }
    
    protected void m_7286_(final GuiGraphics gfx, final float pPartialTick, final int pX, final int pY) {
        gfx.m_280218_(SalvagingScreen.TEXTURE, this.getGuiLeft(), this.getGuiTop(), 0, 0, this.f_97726_, this.f_97727_);
    }
    
    protected void m_280072_(final GuiGraphics gfx, final int x, final int y) {
        final PoseStack stack = gfx.m_280168_();
        stack.m_85836_();
        stack.m_252880_(0.0f, 0.0f, -100.0f);
        final List<Component> tooltip = new ArrayList<Component>();
        tooltip.add((Component)Component.m_237115_("text.apotheosis.salvage_results").m_130944_(new ChatFormatting[] { ChatFormatting.YELLOW, ChatFormatting.UNDERLINE }));
        for (final SalvagingRecipe.OutputData data : this.results) {
            tooltip.add((Component)Component.m_237110_("%s-%s %s", new Object[] { data.min, data.max, data.stack.m_41786_() }));
        }
        if (tooltip.size() > 1) {
            this.drawOnLeft(gfx, (List)tooltip, this.getGuiTop() + 29);
        }
        stack.m_85849_();
        super.m_280072_(gfx, x, y);
    }
    
    static {
        TITLE = (Component)Component.m_237115_("container.apotheosis.salvage");
        TEXTURE = new ResourceLocation("apotheosis", "textures/gui/salvage.png");
    }
}
